Package org.springframework.context.expression

# Class MapAccessor

java.lang.Object
org.springframework.context.expression.MapAccessor

All Implemented Interfaces:
  `org.springframework.asm.Opcodes`, `org.springframework.expression.PropertyAccessor`, `org.springframework.expression.spel.CompilablePropertyAccessor`, `org.springframework.expression.TargetedAccessor`

public class MapAccessor extends Object implements org.springframework.expression.spel.CompilablePropertyAccessor
SpEL `PropertyAccessor` that knows how to access the keys of a standard `Map`.

Since:
  3.0
Author:
  Juergen Hoeller, Andy Clement

## Field Summary

### Fields inherited from interface org.springframework.asm.Opcodes

`AALOAD, AASTORE, ACC_ABSTRACT, ACC_ANNOTATION, ACC_BRIDGE, ACC_DEPRECATED, ACC_ENUM, ACC_FINAL, ACC_INTERFACE, ACC_MANDATED, ACC_MODULE, ACC_NATIVE, ACC_OPEN, ACC_PRIVATE, ACC_PROTECTED, ACC_PUBLIC, ACC_RECORD, ACC_STATIC, ACC_STATIC_PHASE, ACC_STRICT, ACC_SUPER, ACC_SYNCHRONIZED, ACC_SYNTHETIC, ACC_TRANSIENT, ACC_TRANSITIVE, ACC_VARARGS, ACC_VOLATILE, ACONST_NULL, ALOAD, ANEWARRAY, ARETURN, ARRAYLENGTH, ASM10_EXPERIMENTAL, ASM4, ASM5, ASM6, ASM7, ASM8, ASM9, ASTORE, ATHROW, BALOAD, BASTORE, BIPUSH, CALOAD, CASTORE, CHECKCAST, D2F, D2I, D2L, DADD, DALOAD, DASTORE, DCMPG, DCMPL, DCONST_0, DCONST_1, DDIV, DLOAD, DMUL, DNEG, DOUBLE, DREM, DRETURN, DSTORE, DSUB, DUP, DUP_X1, DUP_X2, DUP2, DUP2_X1, DUP2_X2, F_APPEND, F_CHOP, F_FULL, F_NEW, F_SAME, F_SAME1, F2D, F2I, F2L, FADD, FALOAD, FASTORE, FCMPG, FCMPL, FCONST_0, FCONST_1, FCONST_2, FDIV, FLOAD, FLOAT, FMUL, FNEG, FREM, FRETURN, FSTORE, FSUB, GETFIELD, GETSTATIC, GOTO, H_GETFIELD, H_GETSTATIC, H_INVOKEINTERFACE, H_INVOKESPECIAL, H_INVOKESTATIC, H_INVOKEVIRTUAL, H_NEWINVOKESPECIAL, H_PUTFIELD, H_PUTSTATIC, I2B, I2C, I2D, I2F, I2L, I2S, IADD, IALOAD, IAND, IASTORE, ICONST_0, ICONST_1, ICONST_2, ICONST_3, ICONST_4, ICONST_5, ICONST_M1, IDIV, IF_ACMPEQ, IF_ACMPNE, IF_ICMPEQ, IF_ICMPGE, IF_ICMPGT, IF_ICMPLE, IF_ICMPLT, IF_ICMPNE, IFEQ, IFGE, IFGT, IFLE, IFLT, IFNE, IFNONNULL, IFNULL, IINC, ILOAD, IMUL, INEG, INSTANCEOF, INTEGER, INVOKEDYNAMIC, INVOKEINTERFACE, INVOKESPECIAL, INVOKESTATIC, INVOKEVIRTUAL, IOR, IREM, IRETURN, ISHL, ISHR, ISTORE, ISUB, IUSHR, IXOR, JSR, L2D, L2F, L2I, LADD, LALOAD, LAND, LASTORE, LCMP, LCONST_0, LCONST_1, LDC, LDIV, LLOAD, LMUL, LNEG, LONG, LOOKUPSWITCH, LOR, LREM, LRETURN, LSHL, LSHR, LSTORE, LSUB, LUSHR, LXOR, MONITORENTER, MONITOREXIT, MULTIANEWARRAY, NEW, NEWARRAY, NOP, NULL, POP, POP2, PUTFIELD, PUTSTATIC, RET, RETURN, SALOAD, SASTORE, SIPUSH, SOURCE_DEPRECATED, SOURCE_MASK, SWAP, T_BOOLEAN, T_BYTE, T_CHAR, T_DOUBLE, T_FLOAT, T_INT, T_LONG, T_SHORT, TABLESWITCH, TOP, UNINITIALIZED_THIS, V_PREVIEW, V1_1, V1_2, V1_3, V1_4, V1_5, V1_6, V1_7, V1_8, V10, V11, V12, V13, V14, V15, V16, V17, V18, V19, V20, V21, V22, V23, V24, V25, V26, V27, V9`

## Constructor Summary

Constructors
Constructor
Description
`MapAccessor()`
Create a new `MapAccessor` for reading as well as writing.
`MapAccessor(boolean allowWrite)`
Create a new `MapAccessor` for reading and possibly also writing.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`canRead(org.springframework.expression.EvaluationContext context, Object target, String name)`
`boolean`
`canWrite(org.springframework.expression.EvaluationContext context, Object target, String name)`
`void`
`generateCode(String propertyName, org.springframework.asm.MethodVisitor mv, org.springframework.expression.spel.CodeFlow cf)`
`Class<?>`
`getPropertyType()`
`Class<?>[]`
`getSpecificTargetClasses()`
`boolean`
`isCompilable()`
`org.springframework.expression.TypedValue`
`read(org.springframework.expression.EvaluationContext context, Object target, String name)`
`void`
`write(org.springframework.expression.EvaluationContext context, Object target, String name, Object newValue)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### MapAccessor

public MapAccessor()
Create a new `MapAccessor` for reading as well as writing.

See Also:
  - `MapAccessor(boolean)`

### MapAccessor

public MapAccessor(boolean allowWrite)
Create a new `MapAccessor` for reading and possibly also writing.

Parameters:
  `allowWrite` - whether to allow write operations on a target instance
Since:
  6.2
See Also:
  - `canWrite(org.springframework.expression.EvaluationContext, java.lang.Object, java.lang.String)`

## Method Details

### getSpecificTargetClasses

public Class<?>[] getSpecificTargetClasses()

Specified by:
  `getSpecificTargetClasses` in interface `org.springframework.expression.TargetedAccessor`

### canRead

public boolean canRead(org.springframework.expression.EvaluationContext context, @Nullable Object target, String name) throws org.springframework.expression.AccessException

Specified by:
  `canRead` in interface `org.springframework.expression.PropertyAccessor`
Throws:
  `org.springframework.expression.AccessException`

### read

public org.springframework.expression.TypedValue read(org.springframework.expression.EvaluationContext context, @Nullable Object target, String name) throws org.springframework.expression.AccessException

Specified by:
  `read` in interface `org.springframework.expression.PropertyAccessor`
Throws:
  `org.springframework.expression.AccessException`

### canWrite

public boolean canWrite(org.springframework.expression.EvaluationContext context, @Nullable Object target, String name) throws org.springframework.expression.AccessException

Specified by:
  `canWrite` in interface `org.springframework.expression.PropertyAccessor`
Throws:
  `org.springframework.expression.AccessException`

### write

public void write(org.springframework.expression.EvaluationContext context, @Nullable Object target, String name, @Nullable Object newValue) throws org.springframework.expression.AccessException

Specified by:
  `write` in interface `org.springframework.expression.PropertyAccessor`
Throws:
  `org.springframework.expression.AccessException`

### isCompilable

public boolean isCompilable()

Specified by:
  `isCompilable` in interface `org.springframework.expression.spel.CompilablePropertyAccessor`

### getPropertyType

public Class<?> getPropertyType()

Specified by:
  `getPropertyType` in interface `org.springframework.expression.spel.CompilablePropertyAccessor`

### generateCode

public void generateCode(String propertyName, org.springframework.asm.MethodVisitor mv, org.springframework.expression.spel.CodeFlow cf)

Specified by:
  `generateCode` in interface `org.springframework.expression.spel.CompilablePropertyAccessor`